#include <bits/stdc++.h>
using namespace std;
const long long con=100000+100;//100000
vector < int > mas[con];
vector < int > pos(con);
vector < int > vid(con);
int k1=0,n,m;
void viv()
{
    cout<<"YES\n";
    for(int i=0;i<=n;i++)
    {
        cout<<vid[i]<<" ";
    }
    return;
}
void rec(int zar,int in)
{
    k1++;
    pos[zar]=1;
    vid[in]=zar;
    if(k1==n)
    {
        vid[in+1]=1;
        for(auto e:mas[zar])
        {
            if(e==1)
            {
                viv();
                exit(0);
            }
        }
        k1--;
        pos[zar]=0;
        return;
    }
    else
    {
        for(auto e:mas[zar])
        {
            if(pos[e]==0)
            {
                rec(e,in+1);
            }
        }
        k1--;
        pos[zar]=0;
        return;
    }
    return;
}
int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int a,b;
    cin>>n>>m;
    for(int i=0;i<m;i++)
    {
        cin>>a>>b;
        mas[a].push_back(b);
        pos[i]=0;
    }
    rec(1,0);
    cout<<"NO";
    return 0;
}
